﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_list_set_operations
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Make some lists.
            List<Person> list_a = new List<Person>()
            {
                new Person("Art", "Archer"),
                new Person("Bev", "Baker"),
                new Person("Bev", "Baker"),
                new Person("Carl", "Carter"),
                new Person("Carl", "Carter"),
                new Person("Diane", "Dent"),
                new Person("Ed", "Eager"),
                new Person("Ed", "Eager"),
            };

            List<Person> list_b = new List<Person>()
            {
                new Person("Art", "Archer"),
                new Person("Bev", "Baker"),
                new Person("Bev", "Baker"),
                new Person("Carl", "Carter"),
                new Person("Ed", "Eager"),
                new Person("Ed", "Eager"),
                new Person("Fran", "Firth"),
            };

            // Display the values.
            lstA.DataSource = list_a;
            lstB.DataSource = list_b;
            lstAUnionB.DataSource = list_a.Union(list_b).ToList();
            lstAIntersectB.DataSource = list_a.Intersect(list_b).ToList();
            lstAMinusB.DataSource = list_a.Except(list_b).ToList();

            List<Person> intersection = list_a.Intersect(list_b).ToList();
            List<Person> only_a = list_a.Except(intersection).ToList();
            List<Person> only_b = list_b.Except(intersection).ToList();
            List<Person> xor = only_a.Union(only_b).ToList();
            lstAXorB.DataSource = xor;
        }
    }
}
